/*
  Get and put rows of screen pixel data.
*/

#include <string.h>
#include "kernel.h"

unsigned char gx_buffer[720];

/* Gets a row of screen pixel data from the roller RAM and writes it
   to the gx_buffer.
   Parameters: row  screen row, may range from 0 to 31.
 */
void gx_getScreenRow(unsigned char row) {
    unsigned char i;
    unsigned char column;
    unsigned char *pBuffer;

    pBuffer = gx_buffer;
    gx_accModeMC = 0;
    gx_rowMC = row;
    
    for (column = 0; column < 90; column++) {
        gx_colMC = column;
        gx_scrAcc();
        memcpy(pBuffer, 0xF477, 8);
        pBuffer += 8;
    }
}


/* Puts a row of screen pixel data from the gx_buffer to the
   screen roller RAM.
   Parameters: row  screen row, may range from 0 to 31.
 */
void gx_putScreenRow(unsigned char row) {
    unsigned char i;
    unsigned char column;
    unsigned char *pBuffer;

    pBuffer = gx_buffer;
    gx_accModeMC = 1;
    gx_rowMC = row;
    
    for (column = 0; column < 90; column++) {
        memcpy(0xF477, pBuffer, 8);
        pBuffer += 8;
        gx_colMC = column;
        gx_scrAcc();
    }
}

/* Inverts the screen in memory, i.e. without reading the file again.
 */
void invertInMemory(void) {
    unsigned char row;
    int i;

    for (row = 0; row < 32; row++) {
        gx_getScreenRow(row);
        for (i = 0; i < 720; i++) {
            gx_buffer[i] = gx_buffer[i] ^ 0xFF; // XOR
        }
        gx_putScreenRow(row);
    }
}
