
#ifndef __SCREEN_H__
#define __SCREEN_H__

/*
  Get and put rows of screen pixel data.
*/

extern unsigned char gx_buffer[];

/* Gets a row of screen pixel data from the roller RAM and writes it
   to the gx_buffer.
   Parameters: row  screen row, may range from 0 to 31.
 */
void gx_getScreenRow(unsigned char row);

/* Puts a row of screen pixel data from the gx_buffer to the
   screen roller RAM.
   Parameters: row  screen row, may range from 0 to 31.
 */
void gx_putScreenRow(unsigned char row);

/* Inverts the screen in memory, i.e. without reading the file again.
 */
void invertInMemory(void);

#endif /* __SCREEN_H__ */
